
/***************************************************************************
 *  sensor_thread.h - Roomba plugin sensor thread
 *
 *  Created: Mon Jan 03 00:03:42 2011
 *  Copyright  2006-2010  Tim Niemueller [www.niemueller.de]
 *
 ****************************************************************************/

/*  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  Read the full text in the LICENSE.GPL file in the doc directory.
 */

#ifndef _PLUGINS_ROOMBA_SENSOR_THREAD_H_
#define _PLUGINS_ROOMBA_SENSOR_THREAD_H_

#include <aspect/blocked_timing.h>
#include <aspect/logging.h>
#include <core/threading/thread.h>

class Roomba500Thread;

class RoombaSensorThread : public fawkes::Thread,
                           public fawkes::BlockedTimingAspect,
                           public fawkes::LoggingAspect
{
public:
	RoombaSensorThread(Roomba500Thread *roomba500_thread);

	virtual void loop();

	/** Stub to see name in backtrace for easier debugging. @see Thread::run() */
protected:
	virtual void
	run()
	{
		Thread::run();
	}

private:
	Roomba500Thread *roomba500_thread_;
};

#endif
